stages:
  - test
  - release
  - deploy

lint:
  stage: test
  image: python:3.6
  script:
    - pip install flake8
    - flake8 .
  except:
    - master

semantic_release:
  stage: release
  image: node:8
  variables:
      GITLAB_TOKEN: $CI_TOKEN
  before_script:
      - npm install -g semantic-release @semantic-release/gitlab-config
  script:
      - semantic-release -e @semantic-release/gitlab-config
  only:
      - master

image: google/cloud-sdk:alpine
variables:
  VERSION: "$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"

deploy_production:
  stage: deploy
  environment: Production
  only:
  - master
  script:
  - echo $GCP_SERVICE_ACCOUNT > $CI_PIPELINE_ID.json
  - gcloud auth activate-service-account --key-file $CI_PIPELINE_ID.json
  - gcloud config set project $GCP_PROJECT_ID
  - gcloud builds submit --tag gcr.io/$GCP_PROJECT_ID/$GCP_CLOUDRUN_SERVICE --gcs-log-dir=$GCP_GCS_BUILD_LOGS_BUCKET
  - gcloud --quiet components install beta
  - gcloud --quiet beta run deploy $GCP_CLOUDRUN_SERVICE --async --region $GCP_REGION --image gcr.io/$GCP_PROJECT_ID/$GCP_CLOUDRUN_SERVICE --set-env-vars MEDITWEET_CLASSIFIER_MODEL_FILE=$GITLAB_MEDITWEET_CLASSIFIER_MODEL_FILE,MEDITWEET_CLASSIFIER_VOCABULARY_FILE=$GITLAB_MEDITWEET_CLASSIFIER_VOCABULARY_FILE
  after_script:
  - rm $CI_PIPELINE_ID.json
  when:
    manual
